﻿// Project Sword & Gun Copyright © 2021 Kevin Poretti

#pragma once

#include "Modules/ModuleManager.h"
#include "Styling/SlateStyle.h"

class ISNGModuleListenerInterface
{
public:
	virtual void OnStartupModule() {};
	virtual void OnShutdownModule() {};
};

class ISNGModuleInterface : public IModuleInterface
{
public:
	/** IModuleInterface */
	virtual void StartupModule() override;
	virtual void ShutdownModule() override;
	
	virtual void AddModuleListeners() {};

	TSharedPtr<FSlateStyleSet> StyleSet;

protected:
	TArray<TSharedRef<ISNGModuleListenerInterface>> ModuleListeners;
};
