﻿#include "States/SNGStateMachineEditor.h"

#define LOCTEXT_NAMESPACE "SNGStateMachineEditor"

const FName SNGStateMachineEditorAppName = FName(TEXT("SNGStateMachineEditorAppName"));

void FSNGStateMachineEditor::RegisterTabSpawners(const TSharedRef<FTabManager>& InTabManager)
{
	/*
	WorkspaceMenuCategory = TabManager->AddLocalWorkspaceMenuCategory(LOCTEXT("WorkspaceMenu_SNGStateMachineEditor", "SNG State Machine Editor"));
	TSharedRef<FWorkspaceItem> WorkspaceMenuCatRef = WorkspaceMenuCategory.ToSharedRef();
	FAssetEditorToolkit::RegisterTabSpawners(TabManager);
	TabManager->RegisterTabSpawner(GraphCanvasTabId, )
	.SetDisplayName(LOCTEXT("GraphCanvasTab", "Graph"))
		.SetGroup(WorkspaceMenuCategoryRef)
		.SetIcon(FSlateIcon(FEditorStyle::GetStyleSetName(), "GraphEditor.EventGraph_16x"));

	TabManager->RegisterTabSpawner(PropertiesTabId, FOnSpawnTab::CreateSP(this, &FSoundSubmixEditor::SpawnTab_Properties))
		.SetDisplayName(LOCTEXT("PropertiesTab", "Details"))
		.SetGroup(WorkspaceMenuCategoryRef)
		.SetIcon(FSlateIcon(FEditorStyle::GetStyleSetName(), "LevelEditor.Tabs.Details"));\
	*/
}

void FSNGStateMachineEditor::UnregisterTabSpawners(const TSharedRef<FTabManager>& InTabManager)
{
	IStateMachineEditor::UnregisterTabSpawners(InTabManager);
}

FText FSNGStateMachineEditor::GetBaseToolkitName() const
{
	return LOCTEXT("SNGStateMachineEditorAppLabel", "SNG State Machine Editor");
}

FText FSNGStateMachineEditor::GetToolkitName() const
{
	const bool bDirtyState = StateMachineEdited->GetOutermost()->IsDirty();

	/*
	FFormatNamedArguments Args;
	Args.Add(TEXT("StateMachineName", FText::FromString(StateMachineEdited->GetName())));
	Args.Add(TEXT("DirtyState"), bDirtyState ? FText::FromString("*") : FText::GetEmpty());
	return FText::Format(LOCTEXT("SNGStateMachineEditorToolkitName", "{StateMachineName}{DirtyState}"), Args);
	*/
	return FText::FromString(StateMachineEdited->GetName());
}

FText FSNGStateMachineEditor::GetToolkitToolTipText() const
{
	return IStateMachineEditor::GetToolkitToolTipText();
}

FLinearColor FSNGStateMachineEditor::GetWorldCentricTabColorScale() const
{
	return FLinearColor::Blue;
}

FString FSNGStateMachineEditor::GetWorldCentricTabPrefix() const
{
	return FString("NOT IMPLEMENTED");
}

FString FSNGStateMachineEditor::GetDocumentationLink() const
{
	return IStateMachineEditor::GetDocumentationLink();
}

void FSNGStateMachineEditor::SaveAsset_Execute()
{
	FAssetEditorToolkit::SaveAsset_Execute();
}

void FSNGStateMachineEditor::SaveAssetAs_Execute()
{
	IStateMachineEditor::SaveAssetAs_Execute();
}

void FSNGStateMachineEditor::FocusWindow(UObject* ObjectToFocusOn)
{
	BringToolkitToFront();
	//JumpToObject
}

void FSNGStateMachineEditor::InitStateMachineEditor(const EToolkitMode::Type Mode,
                                                    const TSharedPtr<IToolkitHost>& InitToolkitHost, USNGStateMachine* StateMachine)
{
	StateMachineEdited = StateMachine;
	//FAssetEditorToolkit::InitAssetEditor(Mode, InitToolkitHost, SNGStateMachineEditorAppName, , true, true, StateMachine);
}


