﻿// Project Sword & Gun Copyright © 2021 Kevin Poretti

#pragma once

#include "CoreMinimal.h"
#include "IStateMachineEditor.h"
#include "States/SNGStateMachine.h"
#include "Toolkits/SimpleAssetEditor.h"

class FSNGStateMachineEditor : public IStateMachineEditor
{
public:
	/** IToolkit Interface */
	virtual void RegisterTabSpawners(const TSharedRef<FTabManager>& InTabManager) override;
	virtual void UnregisterTabSpawners(const TSharedRef<FTabManager>& InTabManager) override;
	virtual FText GetBaseToolkitName() const override;
	virtual FText GetToolkitName() const override;
	virtual FName GetToolkitFName() const override { return FName(TEXT("SNGStateMachineEditor")); }
	virtual FText GetToolkitToolTipText() const override;
	virtual FLinearColor GetWorldCentricTabColorScale() const override;
	virtual FString GetWorldCentricTabPrefix() const override;

	/** FAssetEditorToolkit interface */
	virtual FString GetDocumentationLink() const override;
	virtual bool CanSaveAsset() const override { return true; }
	virtual bool CanSaveAssetAs() const override { return true; }
	virtual void SaveAsset_Execute() override;
	virtual void SaveAssetAs_Execute() override;

	/** IAssetEditorInstance interface */
	virtual void FocusWindow(UObject* ObjectToFocusOn = nullptr) override;
	
	void InitStateMachineEditor(const EToolkitMode::Type Mode, const TSharedPtr<IToolkitHost>& InitToolkitHost, USNGStateMachine* StateMachine);

private:
	/** State machien being edited */
	USNGStateMachine* StateMachineEdited;
	
	/** Graph Editor */
	TSharedPtr<SGraphEditor> GraphEditorView;


};
