﻿#include "SwordNGunEditor.h"

#include "AssetToolsModule.h"
#include "States/SNGStateMachineTypeActions.h"

IMPLEMENT_GAME_MODULE(FSwordNGunEditor, SwordNGunEditor)

void FSwordNGunEditor::StartupModule()
{
	// register custom types
	// add custom category
	IAssetTools& AssetTools = FModuleManager::LoadModuleChecked<FAssetToolsModule>("AssetTools").Get();
	// register custom asset with SwordNGun category
	EAssetTypeCategories::Type SNGCategory =
		AssetTools.RegisterAdvancedAssetCategory(FName(TEXT("SwordNGun")), FText::FromString("Sword N Gun"));
	TSharedPtr<IAssetTypeActions> Action = MakeShareable(new FSNGStateMachineTypeActions(SNGCategory));
	AssetTools.RegisterAssetTypeActions(Action.ToSharedRef());
	// save for later so it can be unregistered on shutdown
	CreatedAssetTypeActions.Add(Action);
	
	ISNGModuleInterface::StartupModule();
}

void FSwordNGunEditor::ShutdownModule()
{
	// unregister all asset types created by this module 
	if(FModuleManager::Get().IsModuleLoaded("AssetTools"))
	{
		IAssetTools& AssetTools = FModuleManager::GetModuleChecked<FAssetToolsModule>("AssetTools").Get();
		for(int32 i = 0; i < CreatedAssetTypeActions.Num(); i++)
		{
			AssetTools.UnregisterAssetTypeActions(CreatedAssetTypeActions[i].ToSharedRef());
		}
	}
	CreatedAssetTypeActions.Empty();
	
	ISNGModuleInterface::ShutdownModule();
}

void FSwordNGunEditor::AddModuleListeners()
{
	// add tools later
}
